--+------------------------------------------------------------------+
--|                               Copyright © 2016, KOMER Ltd.		 | 
--+------------------------------------------------------------------+

-- Indicator profile initialization routine
-- Defines indicator profile properties and indicator parameters
-- TODO: Add minimal and maximal value of numeric parameters and default color of the streams
function Init()
    indicator:name("Tail / Body Ratio");
    indicator:description("Tail / Body Ratio");
    indicator:requiredSource(core.Bar);
    indicator:type(core.Indicator);
    indicator.parameters:addGroup("Calculation");
    indicator.parameters:addDouble("Multiplier", "Multiplier", "Multiplier", 1);
	
	indicator.parameters:addString("Type", "Type of signal", "", "B");
    indicator.parameters:addStringAlternative("Type", "Tail / Body", "", "B");
    indicator.parameters:addStringAlternative("Type", "Tail / Candle", "", "C");
	
	indicator.parameters:addGroup("Style");
    indicator.parameters:addColor("Basing", "Basing Color", " ", core.rgb(216, 216, 216));
	indicator.parameters:addDouble("Size", "Font Size", "", 5);
end

-- Indicator instance initialization routine
-- Processes indicator parameters and creates output streams
-- TODO: Refine the first period calculation for each of the output streams.
-- TODO: Calculate all constants, create instances all subsequent indicators and load all required libraries
-- Parameters block
local Multiplier;

local first;
local source = nil;
local Type;
-- Streams block
local down, up ;
local Size;
-- Routine
function Prepare(nameOnly)
    Multiplier = instance.parameters.Multiplier;
	Type = instance.parameters.Type;
	Size = instance.parameters.Size;
    source = instance.source;
    first = source:first();

    local name = profile:id() .. "(" .. source:name() .. ", " .. tostring(Multiplier) .. ")";
    instance:name(name);

    if (not (nameOnly)) then
        basing = instance:createTextOutput ("Basing", "Basing", "Wingdings", Size, core.H_Center, core.V_Center, instance.parameters.Basing, 0);
    end
end

-- Indicator calculation routine
-- TODO: Add your code for calculation output values
function Update(period)
    if period >= first and source:hasData(period) then
	
        local Bar = math.abs(source.open[period]- source.close[period]);
        local Tail = source.high[period]-math.max(source.close[period],source.open[period])-source.low[period]+math.min(source.close[period],source.open[period]);
	
        basing:setNoData (period);
		
        if Type ==  "B" and Bar < Tail then
            basing:set(period, (source.open[period]+source.close[period])/2, "\108");
        end
    end
end